<!DOCTYPE html>
<html>

<head>
  <title> Task 35.40 - Filter User</title>
  <meta charset="UTF-8">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.3/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container p-4 text-center">
    <div class="row form-group"><h3><b>Danh Sách người dùng </b></h3></div>
    <div class="row form-group">
      <div class="col-sm-2 text-right">
        <label>Name:</label>
      </div>
      <div class="col-sm-4 text-center">
        <input id="inp-search-name" type="text" placeholder="nhập tên cần tìm...">
      </div>
      <div class="col-sm-3 text-left">
        <button id="btn-search", class="btn btn-success">Tìm Kiếm</button>
      </div>
      
    </div>
    <!-- TODO 1: Thêm 1 dòng mới thủ công ở table trên (thêm thủ công  bằng HTML) -->
    <table id="table-users" class="table table-bordered table-striped table-hover">
      <thead class="table table-bordered bg-info text-white">
        <!-- phần head, dòng tiêu đề  của bảng -->
        <tr style="font-weight:bold;">
          <td> Id </td>
          <td> Name </td>
          <td> Username </td>
          <td> Email</td>
          <td> Address </td>
          <td> Zip code</td>
          <td> Phone</td>
          <td> Company</td>
          <td> Action</td>
        </tr>
      </thead>
      <tbody  id="tbody-users">
        <!-- phần dữ liệu của bảng -->

      </tbody>
    </table>

<script>
     
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var  gResAllUsers="";
      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function(){
    onPageLoading();
  } );
      /*** REGION 3- ***/
  function onPageLoading(){
    console.log("Load Page .........");
    $.ajax({
            url: "https://jsonplaceholder.typicode.com/users/" ,
            type: "GET",
            dataType: "json",
            success: function (resAllUsers) {
                console.log(resAllUsers);
                //showTableUsers(resAllUsers); comment lại cái show cũ
                gResAllUsers=resAllUsers;
                console.log(gResAllUsers);                    //test thử
                console.log(gResAllUsers[8].name);            //test thử
                $(".btn-detail").on("click", function () {
                   onBtnDetailClick(this);
                });
            },
            error: function (ajaxContext) {
                console.log(ajaxContext.responseText);
            },
        });
       
    $("#btn-search").on("click", function(){
      onBtnSearchClick();
    });
  }
  function onBtnDetailClick(paramButton){
    console.log("Id của nó là:" +$(paramButton).data("id"));
    window.location.href="UserDetails.html"+"?id=" +$(paramButton).data("id");
  }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function showOnTableUserFound(paramArrayFound){
    for (var bI=0; bI<paramArrayFound.length; bI++){
      var bRow=""                                 // tạo 1 Element rỗng
      bRow+="<tr>";                               //tạo 1 hàng rổng add vào Elements
      bRow+="<td>"+paramArrayFound[bI].id+"</td>";
      bRow+="<td>"+paramArrayFound[bI].name+"</td>";
      bRow+="<td>"+paramArrayFound[bI].username+"</td>";
      bRow+="<td>"+paramArrayFound[bI].email+"</td>";
      bRow+="<td>"+paramArrayFound[bI].address.suite+","+paramArrayFound[bI].address.street+","+paramArrayFound[bI].address.city+ "</td>";
      bRow+="<td>"+paramArrayFound[bI].address.zipcode+"</td>";
      bRow+="<td>"+paramArrayFound[bI].phone+"</td>";
      bRow+="<td>"+paramArrayFound[bI].company.name+"</td>";
      bRow+="<td>"+ "<button class='btn btn-success btn-detail' data-id ='"+paramArrayFound[bI].id+"' >Chi Tiết</button>"+"</td";

      $("#tbody-users").append(bRow);
    }
  }
 
  function onBtnSearchClick(){
    var vSearchName=$("#inp-search-name").val();
   var vArray=[];
  
   for (var bI=0;bI<gResAllUsers.length; bI++){
      var bNamesInResArray= gResAllUsers[bI].name;
        if(bNamesInResArray.includes(vSearchName)==true){
    vArray.push(gResAllUsers[bI]);}
   }
   console.log(vArray);
   showOnTableUserFound(vArray);
  
       
  }
</script>

</body>

</html>